diff --git a/drivers/block/xen-blkfront.c b/drivers/block/xen-blkfront.c
index 7a1c6b4..6fb77ce 100644
--- a/drivers/block/xen-blkfront.c
+++ b/drivers/block/xen-blkfront.c
@@ -54,8 +54,8 @@
 
 #include <asm/xen/hypervisor.h>
 
-static int sda_is_xvda;
-module_param(sda_is_xvda, bool, 0);
+static int sda_is_xvda = 1;
+module_param(sda_is_xvda, bool, 0644);
 MODULE_PARM_DESC(sda_is_xvda,
 		 "sdX in guest config translates to xvdX, not xvd(X+4)");
 
diff --git a/drivers/idle/intel_idle.c b/drivers/idle/intel_idle.c
index b07ed11..624c77d 100644
--- a/drivers/idle/intel_idle.c
+++ b/drivers/idle/intel_idle.c
@@ -70,8 +70,15 @@ static struct cpuidle_driver intel_idle_driver = {
 	.name = "intel_idle",
 	.owner = THIS_MODULE,
 };
+
 /* intel_idle.max_cstate=0 disables driver */
-static int max_cstate = MWAIT_MAX_NUM_CSTATES - 1;
+/*
+ * Stingray HW uses Nehalem CPU that has several C6 related
+ * errata. Change default idle to avoid C6.
+ *
+ * static int max_cstate = MWAIT_MAX_NUM_CSTATES - 1;
+ */
+static int max_cstate = 2;
 
 static unsigned int mwait_substates;
 
diff --git a/fs/Kconfig b/fs/Kconfig
index c422775..cbc88c4 100644
--- a/fs/Kconfig
+++ b/fs/Kconfig
@@ -4,6 +4,31 @@
 
 menu "File systems"
 
+config SYMLINKOWN
+	bool
+	default y
+	help
+		Apache's SymlinksIfOwnerMatch option has an inherent race condition
+		that prevents it from being used as a security feature.  As Apache
+		verifies the symlink by performing a stat() against the target of
+		the symlink before it is followed, an attacker can setup a symlink
+		to point to a same-owned file, then replace the symlink with one
+		that targets another user's file just after Apache "validates" the
+		symlink -- a classic TOCTOU race.  If you say Y here, a complete,
+		race-free replacement for Apache's "SymlinksIfOwnerMatch" option
+		will be in place for the group you specify. If the sysctl option
+		is enabled, a sysctl option with name "enforce_symlinksifowner" is
+		created.
+
+config SYMLINKOWN_GID
+	int "GID for users with kernel-enforced SymlinksIfOwnerMatch"
+	depends on SYMLINKOWN
+	default 1006
+	help
+		Setting this GID determines what group kernel-enforced
+		SymlinksIfOwnerMatch will be enabled for. If the sysctl option
+		is enabled, a sysctl option with name "symlinkown_gid" is created.
+
 if BLOCK
 
 source "fs/ext2/Kconfig"
diff --git a/fs/exec.c b/fs/exec.c
index b83ce05..2483067 100644
--- a/fs/exec.c
+++ b/fs/exec.c
@@ -817,6 +817,10 @@ static int exec_mmap(struct linux_binprm *bprm)
 	struct task_struct *tsk;
 	struct mm_struct *old_mm, *active_mm, *mm;
 
+	if (virtinfo_notifier_call(VITYPE_GENERAL, VIRTINFO_EXEC,
+				   bprm) & NOTIFY_FAIL)
+		return -EPERM;
+
 	/* Notify parent that we're no longer interested in the old VM */
 	tsk = current;
 	old_mm = current->mm;
diff --git a/fs/fs_struct.c b/fs/fs_struct.c
index 981e2dd..ac019f4 100644
--- a/fs/fs_struct.c
+++ b/fs/fs_struct.c
@@ -115,6 +115,7 @@ struct fs_struct *copy_fs_struct(struct fs_struct *old)
 	}
 	return fs;
 }
+EXPORT_SYMBOL(copy_fs_struct);
 
 int unshare_fs_struct(void)
 {
diff --git a/fs/jbd/journal.c b/fs/jbd/journal.c
index 433c306..50e759d 100644
--- a/fs/jbd/journal.c
+++ b/fs/jbd/journal.c
@@ -121,6 +121,11 @@ static int kjournald(void *arg)
 	journal_t *journal = arg;
 	transaction_t *transaction;
 
+	/* Set the lowest RT prio for faster fsync processing */
+	sched_setscheduler_nocheck(current, SCHED_FIFO,
+				  &(struct sched_param){ .sched_priority =
+							  MAX_RT_PRIO-1 });
+
 	/*
 	 * Set up an interval timer which can be used to trigger a commit wakeup
 	 * after the commit interval expires
diff --git a/fs/jbd2/journal.c b/fs/jbd2/journal.c
index bf43ed2..029f69a 100644
--- a/fs/jbd2/journal.c
+++ b/fs/jbd2/journal.c
@@ -131,6 +131,11 @@ static int kjournald2(void *arg)
 	journal_t *journal = arg;
 	transaction_t *transaction;
 
+	/* Set the lowest RT prio for faster fsync processing */
+	sched_setscheduler_nocheck(current, SCHED_FIFO,
+				  &(struct sched_param){ .sched_priority =
+							  MAX_RT_PRIO-1 });
+
 	/*
 	 * Set up an interval timer which can be used to trigger a commit wakeup
 	 * after the commit interval expires
diff --git a/fs/namei.c b/fs/namei.c
index 0e6a2fb..19a97fe 100644
--- a/fs/namei.c
+++ b/fs/namei.c
@@ -112,6 +112,9 @@
 
 static int __link_path_walk(const char *name, struct nameidata *nd);
 
+static int
+handle_symlink_owner(const struct path *link, const struct inode *target);
+
 /* In order to reduce some races, while at the same time doing additional
  * checking and hopefully speeding things up, we copy filenames to the
  * kernel data space before using them..
@@ -616,6 +619,9 @@ static __always_inline int __do_follow_link(struct path *path, struct nameidata
 		if (unlikely(!audit_dummy_context()))
 			audit_inode(NULL, path->dentry);
 	}
+	if (!error && !(nd->flags & LOOKUP_PARENT) &&
+		handle_symlink_owner(path, nd->path.dentry->d_inode))
+		error = -EACCES;
 	path_put(path);
 
 	return error;
@@ -1058,6 +1064,44 @@ static inline int follow_on_final(struct inode *inode, unsigned lookup_flags)
 		((lookup_flags & LOOKUP_FOLLOW) || S_ISDIR(inode->i_mode));
 }
 
+#ifdef CONFIG_SYMLINKOWN
+int enable_symlinkown = 1;
+int symlinkown_gid = CONFIG_SYMLINKOWN_GID;
+#endif
+
+static int
+handle_symlink_owner(const struct path *link, const struct inode *target)
+{
+#ifdef CONFIG_SYMLINKOWN
+	const struct inode *link_inode = link->dentry->d_inode;
+	const struct cred *cred;
+	int ngroups;
+
+	if (enable_symlinkown && target && link_inode && link_inode->i_uid &&
+		link_inode->i_uid != target->i_uid) {
+		if (enable_symlinkown == 1) {
+			if (in_group_p(symlinkown_gid))
+				goto eacces;
+		} else {
+			cred = current_cred();
+			ngroups = cred->group_info->ngroups;
+			if (ngroups && (GROUP_AT(cred->group_info,
+						ngroups - 1) > symlinkown_gid))
+				goto eacces;
+			if (cred->fsgid > symlinkown_gid)
+				goto eacces;
+		}
+		return 0;
+eacces:
+		if (printk_ratelimit())
+			printk(KERN_DEBUG "access denied %p uid %u target uid %u!\n",
+				link->dentry, link_inode->i_uid, target->i_uid);
+		return -EACCES;
+	}
+#endif
+	return 0;
+}
+
 /*
  * Name resolution.
  * This is the basic name resolution function, turning a pathname into
@@ -1876,6 +1920,7 @@ struct file *do_filp_open(int dfd, const char *pathname,
 	struct nameidata nd;
 	int error;
 	struct path path;
+	struct path link_path;
 	struct dentry *dir;
 	int count = 0;
 	int will_truncate;
@@ -2159,8 +2204,15 @@ do_link:
 	if (!error)
 		got_write = true;
 	mutex_lock(&dir->d_inode->i_mutex);
+	link_path.dentry = path.dentry;
 	path.dentry = lookup_hash(&nd);
 	path.mnt = nd.path.mnt;
+	if (!IS_ERR(path.dentry) &&
+		handle_symlink_owner(&link_path, path.dentry->d_inode)) {
+		error = -EACCES;
+		__putname(nd.last.name);
+		goto exit_mutex_unlock;
+	}
 	__putname(nd.last.name);
 	goto do_last;
 }
diff --git a/fs/namespace.c b/fs/namespace.c
index 10c0efa..140c29e 100644
--- a/fs/namespace.c
+++ b/fs/namespace.c
@@ -35,8 +35,12 @@
 #include <asm/unistd.h>
 #include "pnode.h"
 #include "internal.h"
+#include <linux/vmalloc.h>
 
-#define HASH_SHIFT ilog2(PAGE_SIZE / sizeof(struct list_head))
+/* 256 kb for mount_hashtable */
+#define HASH_PAGES 64
+
+#define HASH_SHIFT ilog2((HASH_PAGES * PAGE_SIZE) / sizeof(struct list_head))
 #define HASH_SIZE (1UL << HASH_SHIFT)
 
 /* spinlock for vfsmount related operations, inplace of dcache_lock */
@@ -2523,8 +2527,8 @@ static struct mnt_namespace *alloc_mnt_ns(void)
  * Allocate a new namespace structure and populate it with contents
  * copied from the namespace of the passed in task structure.
  */
-static struct mnt_namespace *dup_mnt_ns(struct mnt_namespace *mnt_ns,
-		struct fs_struct *fs)
+struct mnt_namespace *dup_mnt_ns(struct mnt_namespace *mnt_ns,
+		struct fs_struct *fs, struct vfsmount *root)
 {
 	struct mnt_namespace *new_ns;
 	struct vfsmount *rootmnt = NULL, *pwdmnt = NULL;
@@ -2537,7 +2541,7 @@ static struct mnt_namespace *dup_mnt_ns(struct mnt_namespace *mnt_ns,
 	down_write(&namespace_sem);
 
 	/* For VE clone only its vfsmount tree */
-	old_root = get_exec_env()->root_path.mnt;
+	old_root = root != NULL ? root : get_exec_env()->root_path.mnt;
 	if (old_root != mnt_ns->root && old_root->mnt_ns == mnt_ns) {
 		/* clone rootfs vfsmount */
 		new_ns->root = clone_mnt(mnt_ns->root,
@@ -2604,6 +2608,7 @@ static struct mnt_namespace *dup_mnt_ns(struct mnt_namespace *mnt_ns,
 
 	return new_ns;
 }
+EXPORT_SYMBOL(dup_mnt_ns);
 
 struct mnt_namespace *copy_mnt_ns(unsigned long flags, struct mnt_namespace *ns,
 		struct fs_struct *new_fs)
@@ -2616,7 +2621,7 @@ struct mnt_namespace *copy_mnt_ns(unsigned long flags, struct mnt_namespace *ns,
 	if (!(flags & CLONE_NEWNS))
 		return ns;
 
-	new_ns = dup_mnt_ns(ns, new_fs);
+	new_ns = dup_mnt_ns(ns, new_fs, NULL);
 
 	put_mnt_ns(ns);
 	return new_ns;
@@ -2843,7 +2848,8 @@ void __init mnt_init(void)
 	mnt_cache = kmem_cache_create("mnt_cache", sizeof(struct vfsmount),
 			0, SLAB_HWCACHE_ALIGN | SLAB_PANIC | SLAB_UBC, NULL);
 
-	mount_hashtable = (struct list_head *)__get_free_page(GFP_ATOMIC);
+	mount_hashtable = (struct list_head *)__vmalloc(HASH_PAGES * PAGE_SIZE,
+							GFP_ATOMIC, PAGE_KERNEL);
 
 	if (!mount_hashtable)
 		panic("Failed to allocate mount hash table\n");
diff --git a/fs/proc/base.c b/fs/proc/base.c
index 8e87b64..ce6d057 100644
--- a/fs/proc/base.c
+++ b/fs/proc/base.c
@@ -3188,6 +3188,9 @@ out:
 	return result;
 }
 
+int proc_can_see_other_uid = 1;
+gid_t proc_super_gid = 0;
+
 /*
  * Find the first task with tgid >= tgid
  *
@@ -3207,8 +3210,14 @@ retry:
 	iter.task = NULL;
 	pid = find_ge_pid(iter.tgid, ns);
 	if (pid) {
-		iter.tgid = pid_nr_ns(pid, ns);
 		iter.task = pid_task(pid, PIDTYPE_PID);
+		if (!proc_can_see_other_uid && !capable(CAP_SYS_RESOURCE) &&
+		    !(proc_super_gid && in_group_p(proc_super_gid)) &&
+		    iter.task && current_euid() != task_euid(iter.task))
+			iter.task = NULL;
+
+		iter.tgid = pid_nr_ns(pid, ns);
+
 		/* What we to know is if the pid we have find is the
 		 * pid of a thread_group_leader.  Testing for task
 		 * being a thread_group_leader is the obvious thing
diff --git a/fs/proc/generic.c b/fs/proc/generic.c
index 2cfe418..3884ec1 100644
--- a/fs/proc/generic.c
+++ b/fs/proc/generic.c
@@ -429,6 +429,41 @@ static const struct dentry_operations proc_dentry_operations =
 	.d_delete	= proc_delete_dentry,
 };
 
+static char *names_white_list[] = {"version", "stat", "uptime",
+"loadavg", "filesystems", "stat", "cmdline", "meminfo", "mounts", "tcp", 
+"tcp6", "udp", "udp6", "assocs", "raw", "raw6", "unix", "dev",
+"net", "cpuinfo" //access to /proc/net/tcp, tcp6, udp, udp6, assocs, raw, raw6, unix
+};
+static int names_white_list_sizes[ARRAY_SIZE(names_white_list)]; 
+static int is_white_list_initialized = 0;
+
+static int proc_check_access(const char *name, int namelen)
+{
+	int i;
+
+	if (!is_white_list_initialized) {
+		for (i = 0; i < ARRAY_SIZE(names_white_list); i++)
+			names_white_list_sizes[i] = strlen(names_white_list[i]);
+		is_white_list_initialized = 1;
+	}
+
+	for (i = 0; i < ARRAY_SIZE(names_white_list); i++) {
+		if (namelen != names_white_list_sizes[i])
+			continue;
+		if (memcmp(name, names_white_list[i], namelen))
+			continue;
+		return 1;
+	}
+
+	return 0;
+}
+
+extern gid_t proc_super_gid;
+#define PDE_IS_NOT_ACCESSIBLY(de)	(!in_group_p(proc_super_gid) \
+									&& !de->access \
+									&& !capable(CAP_SYS_RESOURCE))
+#define PDE_IS_ACCESSIBLY(de)		(!PDE_IS_NOT_ACCESSIBLY(de)) 
+
 struct proc_dir_entry *__proc_lookup(struct proc_dir_entry *dir,
 		const char *name, int namelen)
 {
@@ -444,6 +479,9 @@ struct proc_dir_entry *__proc_lookup(struct proc_dir_entry *dir,
 			continue;
 		break;
 	}
+
+	if (de && PDE_IS_NOT_ACCESSIBLY(de))
+		return NULL;
 	return de;
 }
 EXPORT_SYMBOL(__proc_lookup);
@@ -563,13 +601,15 @@ repeat:
 					goto skip;
 
 				/* filldir passes info to user space */
-				spin_unlock(&proc_subdir_lock);
-				if (filldir(dirent, de->name, de->namelen, filp->f_pos,
-					    de->low_ino, de->mode >> 12) < 0) {
-					de_put(de);
-					goto out;
+				if (PDE_IS_ACCESSIBLY(de)) {
+					spin_unlock(&proc_subdir_lock);
+					if (filldir(dirent, de->name, de->namelen, filp->f_pos,
+							de->low_ino, de->mode >> 12) < 0) {
+						de_put(de);
+						goto out;
+					}
+					spin_lock(&proc_subdir_lock);
 				}
-				spin_lock(&proc_subdir_lock);
 				filp->f_pos++;
 skip:
 				next = de->next;
@@ -694,6 +734,7 @@ static struct proc_dir_entry *__proc_create(struct proc_dir_entry **parent,
 	spin_lock_init(&ent->pde_unload_lock);
 	ent->pde_unload_completion = NULL;
 	INIT_LIST_HEAD(&ent->pde_openers);
+	ent->access = proc_check_access(name, len);
  out:
 	return ent;
 }
diff --git a/include/bc/beancounter.h b/include/bc/beancounter.h
index ffe1a72..961be5d 100644
--- a/include/bc/beancounter.h
+++ b/include/bc/beancounter.h
@@ -110,6 +110,9 @@ struct ubparm {
  */
 #define UB_MAXVALUE	( (1UL << (sizeof(unsigned long)*8-1)) - 1)
 
+extern __u64 ubc_allowed;
+
+#define ub_param_allow(p)	(ubc_allowed & (1 <<(p)))
 
 /*
  *	Resource management structures
diff --git a/include/bc/kmem.h b/include/bc/kmem.h
index 4d33b2f..e7c07f4 100644
--- a/include/bc/kmem.h
+++ b/include/bc/kmem.h
@@ -59,6 +59,9 @@ static inline int ub_kmem_charge(struct user_beancounter *ub,
 	struct ub_percpu_struct *ub_pcpu;
 	unsigned long flags;
 
+	if (!ub_param_allow(UB_KMEMSIZE))
+		ub = get_ub0();
+
 	local_irq_save(flags);
 	ub_pcpu = ub_percpu(ub, smp_processor_id());
 	if (__try_charge_beancounter_percpu(ub, ub_pcpu, UB_KMEMSIZE, size)) {
@@ -75,6 +78,9 @@ static inline void ub_kmem_uncharge(struct user_beancounter *ub,
 	struct ub_percpu_struct *ub_pcpu;
 	unsigned long flags;
 
+	if (!ub_param_allow(UB_KMEMSIZE))
+		ub = get_ub0();
+
 	local_irq_save(flags);
 	ub_pcpu = ub_percpu(ub, smp_processor_id());
 	if (__try_uncharge_beancounter_percpu(ub, ub_pcpu, UB_KMEMSIZE, size))
@@ -85,6 +91,9 @@ static inline void ub_kmem_uncharge(struct user_beancounter *ub,
 static inline int ub_page_charge(struct page *page, int order,
 		struct user_beancounter *ub, gfp_t gfp_mask)
 {
+	if (!ub_param_allow(UB_KMEMSIZE))
+		ub = get_ub0();
+
 	if (ub_kmem_charge(ub, CHARGE_ORDER(order), gfp_mask))
 		return -ENOMEM;
 
@@ -100,6 +109,9 @@ static inline void ub_page_uncharge(struct page *page, int order)
 	if (likely(ub == NULL))
 		return;
 
+	if (!ub_param_allow(UB_KMEMSIZE))
+		ub = get_ub0();
+
 	page->kmem_ub = NULL;
 	BUG_ON(ub->ub_magic != UB_MAGIC);
 	ub_kmem_uncharge(ub, CHARGE_ORDER(order));
diff --git a/include/bc/misc.h b/include/bc/misc.h
index da9670e..e7bce66 100644
--- a/include/bc/misc.h
+++ b/include/bc/misc.h
@@ -27,7 +27,7 @@ UB_DECLARE_FUNC(int, ub_siginfo_charge(struct sigqueue *q,
 UB_DECLARE_VOID_FUNC(ub_siginfo_uncharge(struct sigqueue *q))
 UB_DECLARE_FUNC(int, ub_task_charge(struct user_beancounter *ub))
 UB_DECLARE_VOID_FUNC(ub_task_uncharge(struct user_beancounter *ub))
-UB_DECLARE_VOID_FUNC(ub_task_get(struct user_beancounter *ub,
+UB_DECLARE_VOID_FUNC(ub_task_get(struct task_struct *parent,
 			struct task_struct *task))
 UB_DECLARE_VOID_FUNC(ub_task_put(struct task_struct *task))
 UB_DECLARE_FUNC(int, ub_pty_charge(struct tty_struct *tty))
diff --git a/include/bc/task.h b/include/bc/task.h
index 8f3605a..fb809ab 100644
--- a/include/bc/task.h
+++ b/include/bc/task.h
@@ -12,17 +12,21 @@
 #define __BC_TASK_H_
 
 struct user_beancounter;
-
+struct cgroup;
 
 #ifdef CONFIG_BEANCOUNTERS
 struct task_beancounter {
 	struct user_beancounter	*exec_ub;
 	struct user_beancounter *saved_ub;
 	struct user_beancounter	*task_ub;
+	struct user_beancounter *fork_sub;
 	unsigned long oom_generation;
 };
 
 extern int set_task_exec_ub(struct task_struct *, struct user_beancounter *);
+extern int push_task_ub(struct task_struct *tsk, struct user_beancounter *ub,
+			struct user_beancounter **old_ub,
+			struct cgroup **old_cg);
 
 #define get_task_ub(__task)	((__task)->task_bc.task_ub)
 
diff --git a/include/linux/cgroup.h b/include/linux/cgroup.h
index 81701d2..eebaabb 100644
--- a/include/linux/cgroup.h
+++ b/include/linux/cgroup.h
@@ -29,8 +29,11 @@ extern int cgroup_init_early(void);
 extern int cgroup_init(void);
 extern void cgroup_wq_init(void);
 extern void cgroup_queue_work(struct work_struct *work);
+extern void cgroup_lock_read(void);
 extern void cgroup_lock(void);
+extern bool cgroup_lock_live_group_read(struct cgroup *cgrp);
 extern bool cgroup_lock_live_group(struct cgroup *cgrp);
+extern void cgroup_unlock_read(void);
 extern void cgroup_unlock(void);
 extern void cgroup_fork(struct task_struct *p);
 extern void cgroup_fork_callbacks(struct task_struct *p);
@@ -234,6 +237,7 @@ struct cgroup {
 
 	/* For RCU-protected deletion */
 	struct rcu_head rcu_head;
+	struct work_struct free_work;
 
 #ifndef __GENKSYMS__
 	/* List of events which userspace want to recieve */
@@ -654,7 +658,9 @@ static inline void cgroup_fork_callbacks(struct task_struct *p) {}
 static inline void cgroup_post_fork(struct task_struct *p) {}
 static inline void cgroup_exit(struct task_struct *p, int callbacks) {}
 
+static inline void cgroup_lock_read(void) {}
 static inline void cgroup_lock(void) {}
+static inline void cgroup_unlock_read(void) {}
 static inline void cgroup_unlock(void) {}
 static inline int cgroupstats_build(struct cgroupstats *stats,
 					struct dentry *dentry)
diff --git a/include/linux/fairsched.h b/include/linux/fairsched.h
index c1da896..57faaab 100644
--- a/include/linux/fairsched.h
+++ b/include/linux/fairsched.h
@@ -18,6 +18,11 @@
 #ifdef __KERNEL__
 
 #ifdef CONFIG_VZ_FAIRSCHED
+struct cgroup;
+struct task_struct;
+
+extern struct cgroup *fairsched_root;
+extern struct cgroup *fairsched_host;
 
 #define FSCHWEIGHT_MAX		((1 << 16) - 1)
 #define FSCHRATE_SHIFT		10
diff --git a/include/linux/mnt_namespace.h b/include/linux/mnt_namespace.h
index 00bf392..5376bfc 100644
--- a/include/linux/mnt_namespace.h
+++ b/include/linux/mnt_namespace.h
@@ -33,6 +33,8 @@ extern void unregister_mounts_reader(struct proc_mounts *p);
 struct fs_struct;
 
 extern struct mnt_namespace *create_mnt_ns(struct vfsmount *mnt);
+struct mnt_namespace *dup_mnt_ns(struct mnt_namespace *mnt_ns,
+		struct fs_struct *fs, struct vfsmount *new_root);
 extern struct mnt_namespace *copy_mnt_ns(unsigned long, struct mnt_namespace *,
 		struct fs_struct *);
 extern void put_mnt_ns(struct mnt_namespace *ns);
diff --git a/include/linux/nsproxy.h b/include/linux/nsproxy.h
index 4cd6b2f..15c7191 100644
--- a/include/linux/nsproxy.h
+++ b/include/linux/nsproxy.h
@@ -64,6 +64,8 @@ static inline struct nsproxy *task_nsproxy(struct task_struct *tsk)
 
 struct nsproxy *duplicate_nsproxy(struct nsproxy *nsproxy);
 int copy_namespaces(unsigned long flags, struct task_struct *tsk, int force_admin);
+struct nsproxy *dup_ns(unsigned long flags,
+			struct nsproxy *ns, struct fs_struct *new_fs);
 void exit_task_namespaces(struct task_struct *tsk);
 void switch_task_namespaces(struct task_struct *tsk, struct nsproxy *new);
 void free_nsproxy(struct nsproxy *ns);
diff --git a/include/linux/proc_fs.h b/include/linux/proc_fs.h
index 0bc504d..7f93b63 100644
--- a/include/linux/proc_fs.h
+++ b/include/linux/proc_fs.h
@@ -76,6 +76,7 @@ struct proc_dir_entry {
 	spinlock_t pde_unload_lock; /* proc_fops checks and pde_users bumps */
 	struct completion *pde_unload_completion;
 	struct list_head pde_openers;	/* who did ->open, but not ->release */
+	int access;
 };
 
 enum kcore_type {
diff --git a/include/linux/sched.h b/include/linux/sched.h
index 25a3e49..d61d675 100644
--- a/include/linux/sched.h
+++ b/include/linux/sched.h
@@ -164,6 +164,9 @@ extern unsigned long nr_running_ve(void);
 
 extern void calc_global_load(void);
 
+extern void loadavg_ptr_init(void (*ptr)(void));
+extern void loadavg_ptr_fini(void);
+
 extern unsigned long get_parent_ip(unsigned long addr);
 
 struct seq_file;
@@ -1245,8 +1248,6 @@ struct sched_class {
 #ifndef __GENKSYMS__
 	bool (*yield_to_task) (struct rq *rq, struct task_struct *p, bool preempt);
 #endif
-
-	void (*task_scheduled) (struct rq *rq, struct task_struct *p);
 };
 
 struct load_weight {
@@ -1737,8 +1738,21 @@ struct task_struct {
 	} memcg_batch;
 #endif
 #endif
+	spinlock_t		tags_lock;
+	struct list_head	tags_list;
+};
+
+struct fake_tag;
+typedef void (*fake_tag_cb)(struct fake_tag *ptr);
+
+struct fake_tag {
+	struct list_head tag_link;
+	uint32_t	tag_magic;
+	fake_tag_cb	tag_fini;
+	char		data[0];
 };
 
+
 /* Future-safe accessor for struct task_struct's cpus_allowed. */
 #define tsk_cpus_allowed(tsk) (&(tsk)->cpus_allowed)
 
@@ -2948,6 +2962,14 @@ extern unsigned long sched_group_shares(struct task_group *tg);
 extern int sched_cgroup_set_shares(struct cgroup *cgrp, unsigned long shares);
 unsigned long sched_cgroup_get_shares(struct cgroup *cgrp);
 extern unsigned long sched_cgroup_get_nr_running(struct cgroup *cgrp);
+extern unsigned long sched_cgroup_get_nr_sleep(struct cgroup *cgrp);
+#else
+static inline unsigned long sched_cgroup_get_nr_running(struct cgroup *cgrp) {
+	return 0;
+}
+static inline unsigned long sched_cgroup_get_nr_sleep(struct cgroup *cgrp) {
+	return 0;
+}
 #endif
 #ifdef CONFIG_RT_GROUP_SCHED
 extern int sched_group_set_rt_runtime(struct task_group *tg,
diff --git a/include/linux/ve.h b/include/linux/ve.h
index b8641ce..0a15de7 100644
--- a/include/linux/ve.h
+++ b/include/linux/ve.h
@@ -132,6 +132,8 @@ struct svc_rqst;
 struct cgroup;
 struct css_set;
 
+struct user_beancouter;
+
 struct ve_struct {
 	struct list_head	ve_list;
 	wait_queue_head_t	ve_list_wait;
@@ -155,6 +157,9 @@ struct ve_struct {
 	/* see vzcalluser.h for VE_FEATURE_XXX definitions */
 	__u64			features;
 
+/* VE root UBC */
+	struct user_beancounter *vs_ubc;
+
 /* VE's root */
 	struct path		root_path;
 
diff --git a/include/linux/virtinfo.h b/include/linux/virtinfo.h
index cce377f..0bbf7c9 100644
--- a/include/linux/virtinfo.h
+++ b/include/linux/virtinfo.h
@@ -65,6 +65,7 @@ int meminfo_proc_show_ub(struct seq_file *m, void *v,
 #define VIRTINFO_SYSINFO	2
 #define VIRTINFO_VMSTAT		3
 #define VIRTINFO_OOMKILL	4
+#define VIRTINFO_EXEC		5
 
 #define VIRTINFO_IO_ACCOUNT	0
 #define VIRTINFO_IO_PREPARE	1
